package nameCompletion {
	function toggleFirstPerson(%tog) {
		%text = NMH_Type.getValue();
		
		if(%text $= "") 
		{
			parent::toggleFirstPerson(%tog);
			return;
		}
		
		if(!%tog)
			return;
			
		%last = getWord(%text, getWordCount(%text) - 1);
		%closeName = findPartialName(%last);
		
		if(strLen(%last) < 2 || %closeName == -1) 
		{
			parent::toggleFirstPerson(%tog);
			return;
		}
		
		if(%closeName != -1)
		{
			%text = removeWord(%text, getWordCount(%text) - 1);
			if(getWordCount(%text) >= 1)
				%text = %text SPC %closeName;
			else
				%text = %text @ %closeName;
			NMH_Type.setValue(%text);
		}
	}
	
	function newMessageHud::onSleep(%this) 
	{
		parent::onSleep(%this);
		NMH_Type.setValue("");
	}
};
activatePackage(nameCompletion);

function findPartialName(%partialName) 
{
	%partialName = strLwr(%partialName);
	%bestName = -1;
	%bestPos = -1;
	for(%i=0; %i < NPL_List.rowCount(); %i++) 
	{
		%name = strLwr(getField(NPL_List.getRowText(%i), 1));
		%pos = strStr(%name, %partialName);
		if(%pos > %bestPos) 
		{
			%bestPos = %pos;
			%bestName = %name;
		}
	}
	if(%bestName == -1)
		return -1;
	return fixCasesByName(%bestName);
}

function fixCasesByName(%name) 
{
	for(%i=0; %i < NPL_List.rowCount(); %i++) 
	{
		%compare = getField(NPL_List.getRowText(%i), 1);
		if(%name $= %compare)
			return %compare;
	}
	return -1;
}